# drop_empty_cols_action Class Reference

Physically removes empty columns in presolve, and reinserts empty columns in postsolve. More...

`#include <CoinPresolveEmpty.hpp>`

Inheritance diagram for drop_empty_cols_action:
[legend]
Collaboration diagram for drop_empty_cols_action:
[legend]

List of all members.

## Classes
struct | action
## Public Member Functions
const char * | name () const
| A name for debug printing.
void | postsolve (CoinPostsolveMatrix *prob) const
| Apply the postsolve transformation for this particular presolve action.
virtual | ~drop_empty_cols_action ()
## Static Public Member Functions
static const CoinPresolveAction * | presolve (CoinPresolveMatrix *, const int *ecols, int necols, const CoinPresolveAction *)
static const CoinPresolveAction * | presolve (CoinPresolveMatrix *prob, const CoinPresolveAction *next)
## Private Member Functions
| drop_empty_cols_action (int nactions, const action *const actions, const CoinPresolveAction *next)
## Private Attributes
const int | nactions_
const action *const | actions_

## Detailed Description

Physically removes empty columns in presolve, and reinserts empty columns in postsolve.

Physical removal of rows and columns should be the last activities performed during presolve. Do them exactly once. The row-major matrix is not maintained by this transform.

To physically drop the columns, CoinPrePostsolveMatrix::mcstrt_ and CoinPrePostsolveMatrix::hincol_ are compressed, along with column bounds, objective, and (if present) the column portions of the solution. This renumbers the columns. drop_empty_cols_action::presolve will reconstruct CoinPresolveMatrix::clink_.

Todo:
  Confirm correct behaviour with solution in presolve.

Definition at line 34 of file CoinPresolveEmpty.hpp.

## Constructor & Destructor Documentation

drop_empty_cols_action::drop_empty_cols_action | ( | int | nactions,
|  | const action *const | actions,
|  | const CoinPresolveAction * | next |
| ) |  |  | `[inline, private]`

Definition at line 47 of file CoinPresolveEmpty.hpp.

virtual drop_empty_cols_action::~drop_empty_cols_action | ( |  | ) | `[inline, virtual]`

Definition at line 68 of file CoinPresolveEmpty.hpp.

## Member Function Documentation

const char* drop_empty_cols_action::name | ( |  | ) | const`[inline, virtual]`

A name for debug printing.

It is expected that the name is not stored in the transform itself.

Implements CoinPresolveAction.

Definition at line 56 of file CoinPresolveEmpty.hpp.

static const CoinPresolveAction* drop_empty_cols_action::presolve | ( | CoinPresolveMatrix * | ,
|  | const int * | ecols,
|  | int | necols,
|  | const CoinPresolveAction * |  |
| ) |  |  | `[static]`

static const CoinPresolveAction* drop_empty_cols_action::presolve | ( | CoinPresolveMatrix * | prob,
|  | const CoinPresolveAction * | next |
| ) |  |  | `[static]`

void drop_empty_cols_action::postsolve | ( | CoinPostsolveMatrix * | prob | ) | const`[virtual]`

Apply the postsolve transformation for this particular presolve action.

Implements CoinPresolveAction.

## Member Data Documentation

const int drop_empty_cols_action::nactions_`[private]`

Definition at line 36 of file CoinPresolveEmpty.hpp.

const action* const drop_empty_cols_action::actions_`[private]`

Definition at line 45 of file CoinPresolveEmpty.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/CoinUtils-2.9.4/CoinUtils/src/CoinPresolveEmpty.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines